<?php
/**
 * @version		1.5.3.47 controllers/categories.php
 * @package		J2XML
 * @subpackage	com_j2xml
 * @since		1.5.3
 * 
 * @author		Helios Ciancio <info@eshiol.it>
 * @link		http://www.eshiol.it
 * @copyright	Copyright (C) 2010 Helios Ciancio. All Rights Reserved
 * @license		http://www.gnu.org/licenses/gpl-3.0.html GNU/GPL v3
 * J2XML is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 */
 
// no direct access
defined('_JEXEC') or die('Restricted access.');

jimport('joomla.application.component.controller');

require_once (JPATH_COMPONENT.DS.'helpers'.DS.'exporter.php');
require_once (JPATH_COMPONENT.DS.'helpers'.DS.'sender.php');
require_once (JPATH_COMPONENT.DS.'helpers'.DS.'version.php');

/**
 * Categories controller class.
 */
class J2XMLControllerCategories extends JController
{	
	function __construct($default = array())
	{
		parent::__construct();
	}

	function display()
	{
		JRequest::setVar('view', 'categories');
		parent::display();
	}
	
	/**
	 * Export articles in XML format
	 */
	function export()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit('Invalid Token');

		$cid = JRequest::getVar('cid', array(0), 'post', 'array');
		$ids = 'cid='.implode(',', $cid);
		$this->setRedirect('index.php?option=com_j2xml&task=categories.display&format=raw&'.$ids);
	}

	/**
	 * Send articles in XML format
	 */
	function send()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit('Invalid Token');
		
		$ids = JRequest::getVar('cid');		
		$sid = JRequest::getVar('j2xml_send_id');
		
		$params =& JComponentHelper::getParams('com_j2xml');
		$images = array();
		
		$xml = J2XMLExporter::categories($ids,
			$params->get('export_images', '1'),
			true,
			$params->get('export_users', '1'),
			$images
		);
		foreach ($images as $image)
			$xml .= $image;
		$res = J2XMLSender::send(
				$xml,		
				$params->get('debug', 0), 
				$params->get('export_gzip', '0'),
				$sid
			);
		if ($res || $params->get('debug') == 0)
			$this->setRedirect(@$_SERVER['HTTP_REFERER']);		
	}
}
?>
